---
title: Using the Beacon API
slug: Web/API/Beacon_API/Using_the_Beacon_API
tags:
  - Guide
  - Web Performance
---
<div>{{DefaultAPISidebar("Beacon")}}{{SeeCompatTable}}</div>

<p>The <strong><code>Beacon</code></strong> interface schedules an asynchronous and non-blocking request to a web server.</p>

<ul>
 <li>Beacon requests use HTTP <code>POST</code> and do not require a response.</li>
 <li>Beacon requests are guaranteed to be initiated before the page unloads.</li>
</ul>

<p>This document contains examples of the Beacon interfaces. See {{domxref("Beacon_API","Beacon API")}} for an overview.</p>

<h2 id="Navigator.sendBeacon()">Navigator.sendBeacon()</h2>

<p>The Beacon API's {{domxref("Navigator.sendBeacon()")}} method sends a <em>beacon</em> request to the server in the <em>global browsing context</em>. The method takes two arguments: the <code>URL</code> and the <code>data</code> to send. The <code>data</code> argument is optional and its type may be an {{domxref("ArrayBufferView")}}, {{domxref("Blob")}}, {{domxref("DOMString")}}, or {{domxref("FormData")}}.</p>

<p>If the browser successfully queues the request for delivery, the method returns <code>true</code> and returns <code>false</code> otherwise.</p>

<p>The following example specifies a handler for the {{event("load")}} and {{event("beforeunload")}} events. The handler calls <code>sendBeacon()</code> with the current URL.</p>

<pre class="brush: js">window.onload = window.onunload = function analytics(event) {
  if (!navigator.sendBeacon) return;

  var url = "https://example.com/analytics";
  // Create the data to send
  var data = "state=" + event.type + "&amp;location=" + location.href;

  // Send the beacon
  var status = navigator.sendBeacon(url, data);

  // Log the data and result
  console.log("sendBeacon: URL = ", url, "; data = ", data, "; status = ", status);
};
</pre>

<p>The following example creates a {{event("submit")}} handler and when that event is fired, the handler calls <code>sendBeacon()</code>.</p>

<pre class="brush: js">window.onsubmit = function send_analytics() {
  var data = JSON.stringify({
    location: location.href,
    time: Date()
  });

  navigator.sendBeacon('/analytics', data);
};
</pre>

<h2 id="See_Also">See Also</h2>

<ul>
 <li>{{domxref("Beacon_API","Beacon API")}} (Overview)</li>
 <li><a href="https://w3c.github.io/beacon/">Beacon standard</a></li>
 <li><a href="http://caniuse.com/#search=beacon">Beacon CanIUse data</a></li>
</ul>
